<template>
  <b-container>
    <Price :price="getConfigurationPrice"></Price>
    <div class="accordion" role="tablist">
      <b-card no-body class="mb-1"
              v-for="questionSet in questionSets"
              v-bind:key="questionSet.reference">

        <b-card-header header-tag="header" class="p-0" role="tab">
          <b-button block v-b-toggle="`${questionSet.reference}-collapse`"
                    variant="info"
                    @click="changeQuestionSetFocus()">
            <span class="float-left">
              <b-icon v-if="isQuestionSetModified(questionSet.reference)" icon="pencil"></b-icon>
              <b-icon v-else-if="isQuestionSetAnswered(questionSet.reference)"
                      icon="check" class="check-green"></b-icon>
              <b-icon v-else icon="x"></b-icon>
            </span>
            {{questionSet.title}}
          </b-button>
        </b-card-header>

        <b-collapse :id="`${questionSet.reference}-collapse`"
                    :visible="hasQuestionSetFocus(questionSet.reference)"
                    accordion="accordion" role="tabpanel">
          <b-card-body>
            <b-card-text
                :id="`${question.reference}`"
                v-for="question in questionSet.questions"
                v-bind:key="question.reference">
              <QuestionField
                  :questionSetReference="questionSet.reference"
                  :question="question"
                  :answer="getAnswerForQuestion(questionSet.reference, question.reference)">
              </QuestionField>
            </b-card-text>
            <b-row class="ml-1">
              <b-button v-if="isQuestionSetModified(questionSet.reference) || !isQuestionSetAnswered(questionSet.reference)"
                        variant="success" @click="submitQuestionSetAnswers(questionSet.reference)">
                Volgende stap
              </b-button>
            </b-row>
          </b-card-body>

        </b-collapse>
      </b-card>

      <b-card no-body class="mb-1">

        <b-card-header header-tag="header" class="p-0" role="tab">
          <div class="btn btn-block btn-info">
            Samenstelling afronden
          </div>
        </b-card-header>

        <b-card-body v-if="isCompleted">
          <b-card-text>
            <Quote
                :questionSets="questionSets"
                :answers="getAnswers"
                :price="getConfigurationPrice">
            </Quote>
            <b-button variant="success" class="btn-lg mt-3" @click="completeConfiguration()">
              Samenstelling afronden!
              <span v-if="isConfigurationCompletePending"
                    class="spinner-border spinner-border-sm" role="status">
              <span class="sr-only">Laden..</span>
            </span>
            </b-button>
          </b-card-text>
        </b-card-body>
      </b-card>
    </div>

  </b-container>
</template>

<script>
import axios from "axios";
import {mapGetters} from "vuex";

import {
  CONF_ANSWER_SUBMIT_REQUEST,
  CONF_ANSWERS_REQUEST,
  CONF_COMPLETE_REQUEST,
  CONF_PRICE_REQUEST
} from "@/store/actions/configuration";
import QuestionField from "@/components/configuration/QuestionField";
import Price from "@/components/configuration/Price";
import Quote from "@/components/configuration/Quote";

export default {
  name: "Configuration",
  components: {
    QuestionField,
    Price,
    Quote
  },
  data() {
    return {
      questionSets: {},
      activeQuestionSetReference: null,
      isCompleted: false
    }
  },
  methods: {
    getQuestions: function() {
      axios({
        url: `/configuration/${this.$store.getters.configurationId}/questions/`,
        method: 'get',
      }).then(response => {
        if(response.data.length === 0){
          this.$router.push('/products');
        }
        this.questionSets = response.data.question_sets
        this.setFocusFirstUnansweredQuestion()
        this.$store.dispatch(CONF_PRICE_REQUEST)
      }).catch(error => {
        console.log(error)
        this.$router.push('/products')
      })
    },
    setFocusFirstUnansweredQuestion: function(){
      for(let i = 0; i < this.questionSets.length; i++){
        let questionSetReference = this.questionSets[i].reference
        if(!this.$store.getters.isQuestionSetAnswered(questionSetReference)){
          this.activeQuestionSetReference = questionSetReference
          return
        }
      }
      this.isCompleted = true;
      this.activeQuestionSetReference = null
    },
    hasQuestionSetFocus(questionSetReference) {
      return this.activeQuestionSetReference === questionSetReference
    },
    changeQuestionSetFocus: function() {
      this.activeQuestionSetReference = null
    },
    submitQuestionSetAnswers(questionSetReference) {
      let questionSetAnswers = this.$store.getters.getQuestionSetAnswers(questionSetReference)
      let answerKeys = Object.keys(questionSetAnswers)

      let body = {
        question_set_reference: questionSetReference,
        answers: {}
      }
      for(let i = 0; i < answerKeys.length; i++) {
        body['answers'][answerKeys[i]] = questionSetAnswers[answerKeys[i]]
      }

      this.$store.dispatch(CONF_ANSWER_SUBMIT_REQUEST, body).then(() => {
        this.$root.$emit('bv::toggle::collapse', `${questionSetReference}-collapse`)
        this.setFocusFirstUnansweredQuestion()
        this.$store.dispatch(CONF_PRICE_REQUEST)
      })
    },
    completeConfiguration: function() {
      this.$store.dispatch(CONF_COMPLETE_REQUEST).then(() => {
        this.$router.push('/products')
      })
    }
  },
  computed: {
    ...mapGetters([
      'configurationId',
      'getAnswers',
      'getAnswerForQuestion',
      'isQuestionSetAnswered',
      'isQuestionSetModified',
      'isConfigurationCompletePending',
      'getConfigurationPrice'
    ])
  },
  mounted() {
    this.$store.dispatch(CONF_ANSWERS_REQUEST)
      .then(() => {
        this.getQuestions()
      })
      .catch(error => {
        this.$set(this, 'errors', error.response.data)
        this.$router.push('/products')
      })
  }
}
</script>

<style scoped>
.check-green {
  color: #32fa32;
}
</style>
